#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <stddef.h>
#include <time.h>
#include <math.h>
#include <string.h>
#include <ctype.h>

#include "tx_scanner.h"
/*************************************************************************
ڲ궨
*************************************************************************/


/*************************************************************************
ڲṹö١Ƚṹ
*************************************************************************/

/*************************************************************************
ڲ̬

ȫֱ

extern ⲿ

*************************************************************************/


/*************************************************************************
̬

extern ⲿ
*************************************************************************/
/**ݻص**/
static int32 tx_scanner_sdk_decode_data_cb(uint8 ucCodeType, uint8 *pBuf, uint32 uiBufLen);

/**״̬ص**/
static void tx_scanner_sdk_comm_state_cb_fun(uint8 ucState);
static void tx_scanner_sdk_show_menu();
/*************************************************************************

*************************************************************************/
int main()
{
	int32 iRet;
	uint8 ucVer[64] = "";
	uint8 ucsend[64] = "";
	uint8 ucTemp1;
	uint8 ucTemp2;
	uint8 ucPortBuf[32] = "/dev/ttyUSB0"; 
	uint8 ucInput[64] = "";
	TS_UART_T s_tTsUart;
	uint16 usTimeMs;
	uint32 uiTimeMs;
	
	memset(&s_tTsUart, 0, sizeof(s_tTsUart));

	printf("/***************************************************\r\n");
	printf("please input the parameters\r\n");
	printf("input the device name,(Press Enter to enter the default value)exampel--\n"
		"choose /dev/ttyACM0 or /dev/ttyUSB0\r\n");
	memcpy(s_tTsUart.ucCom,ucPortBuf,strlen(ucPortBuf)+1);//豸
	fgets(ucInput,sizeof(ucInput),stdin);
	if (ucInput[0] != '\n');
	{
		sscanf(ucInput,"%s",s_tTsUart.ucCom);
	}
	
	printf("input the Baud rate,(Press Enter to enter the default value)choose(options:represent)exampel--10\n"
	"(0:300,\n"
	"1:600,\n"
	"2:1200,\n"
	"3:2400,\n"
	"4:4800,\n"
	"5:9600,\n"
	"6:14400,\n"
	"7:19200,\n"
	"8:38400,\n"
	"9:57600,\n"
	"10:115200,\n"
	"11:128000,\n"
	"12:192000,\n"
	"13:256000)\r\n");
	s_tTsUart.eBaudrate=TS_BAUD_115200;//
	fgets(ucInput,sizeof(ucInput),stdin);
	if (ucInput[0] != '\n');
	{
		sscanf(ucInput,"%u",&s_tTsUart.eBaudrate);
	}
	
	printf("input the Databits,(Press Enter to enter the default value)choose(options:represent)exampel--3(0:5,1:6,2:7,3:8)\r\n");
	s_tTsUart.eDataBits=TS_DATA_BITS_8;//λ
	fgets(ucInput,sizeof(ucInput),stdin);
	if (ucInput[0]!= '\n');
	{
		sscanf(ucInput,"%u",&s_tTsUart.eDataBits);
	}
	
	printf("input the Stopbits,(Press Enter to enter the default value)choose(options:represent)exampel--0(0:1,2:1.5,3:2)\r\n");
	s_tTsUart.eStopBits=TS_STOP_BITS_1;//ֹͣλ
	fgets(ucInput,sizeof(ucInput),stdin);
	if (ucInput[0]!= '\n');
	{
		sscanf(ucInput,"%u",&s_tTsUart.eStopBits);
	}
	
	printf("input the Parity,(Press Enter to enter the default value)choose(options:represent)exampel--0(0:N,1:O,2:E,3:MARK,4:SPACE)\r\n");
	s_tTsUart.eParityBits=TS_PARITY_BITS_NONE;//Уλ
	fgets(ucInput,sizeof(ucInput),stdin);
	if (ucInput[0]!= '\n');
	{
		sscanf(ucInput,"%u",&s_tTsUart.eParityBits);
	}
	
	printf("input the Flowctrl,(Press Enter to enter the default value)choose(options:represent)exampel--0(0:FW_NONE,1:HARDWARE,2:SOFTWARE)\r\n");
	s_tTsUart.eFlowCtl=TS_FW_NONE;//
	fgets(ucInput,sizeof(ucInput),stdin);
	if (ucInput[0]!= '\n');
	{
		sscanf(ucInput,"%u",&s_tTsUart.eFlowCtl);
	}
	printf("******************************************************\r\n");

	tx_scanner_get_version(ucVer, sizeof(ucVer));
	printf("linux c/c++ uart demo ver:%s\r\n", ucVer);

	/**עݻص**/
	iRet = tx_scanner_decode_data_fun_register(tx_scanner_sdk_decode_data_cb);
	if(iRet < 0)
	{
		printf("tx_scanner_decode_data_fun_register fail!!!\r\n");
		return 1;
	}

	iRet = tx_scanner_comm_state_fun_register(tx_scanner_sdk_comm_state_cb_fun);
	if(iRet < 0)
	{
		printf("tx_scanner_comm_state_fun_register fail!!!\r\n");
		return 1;
	}

	/**ʼ**/
	iRet = tx_scanner_init();
	if(iRet < 0)
	{
		printf("tx_scanner_init fail!!!\r\n");
		return 1;
	}

	iRet = tx_scanner_uart_open(s_tTsUart);
	if(iRet < 0)
	{
		printf("tx_scanner_uart_open fail!!!\r\n");
		return 1;
	}
	else
	{
		printf("UART open succ!!!\r\n");
	}

	printf("******************************************************\r\n");
	printf("a:start decode\r\n");
	printf("b:stop decode\r\n");
	printf("c:no time decode start\r\n");
	printf("d:get version info\r\n");
	printf("e:get product info\r\n");
	printf("f:set trigger mode; 0:LEVEL,1:PULSE,2:CONTINUOUS,3:AUTOSENS; save:0:no,1:yes.(eg:f01)\r\n");
	printf("g:get trigger mode\r\n");
	printf("h:set light LED; 0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:h01)\r\n");
	printf("i:get light LED\r\n");
	printf("?/m:more menu\r\n");
	printf("q:quit\r\n");
	printf("******************************************************\r\n");
	
	while(1)
	{
		switch(getchar())
		{
			case 'a':
			case 'A':
				iRet = tx_scanner_decode_start();
				if(iRet < 0)
					printf("tx_scanner_decode_start fail!!!\r\n");
				else
					printf("start\r\n");
				break;

			case 'b':
			case 'B':
				iRet = tx_scanner_decode_stop();
				if(iRet < 0)
					printf("tx_scanner_decode_stop fail!!!\r\n");
				else
					printf("stop\r\n");
				break;

			case 'c':
			case 'C':
				iRet = tx_scanner_no_time_decode_start();
				if(iRet < 0)
					printf("tx_scanner_no_time_decode_start fail!!!\r\n");
				else
					printf("no time start\r\n");
				break;

			case 'd':
			case 'D':
				{
					uint8 ucVerInfo[128] = "";
				
					iRet = tx_scanner_get_version_info(ucVerInfo, sizeof(ucVerInfo));
					if(iRet < 0)
						printf("tx_scanner_get_version_info fail!!!\r\n");
					else
						printf("%s\r\n", ucVerInfo);
				}
				break;

			case 'e':
			case 'E':
				{
					uint8 ucProInfo[128] = "";
				
					iRet = tx_scanner_get_all_product_info(ucProInfo, sizeof(ucProInfo));
					if(iRet < 0)
						printf("tx_scanner_get_all_product_info fail!!!\r\n");
					else
						printf("%s\r\n", ucProInfo);
				}
				break;

			case 'f':
			case 'F':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_trigger_mode(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_trigger_mode fail!!!\r\n");
				break;

			case 'g':
			case 'G':
				iRet = tx_scanner_get_trigger_mode();
				printf("tx_scanner_get_trigger_mode:%d\r\n", iRet);
				break;		

			case 'h':
			case 'H':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_light_state(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_light_state fail!!!\r\n");
				break;

			case 'i':
			case 'I':
				
				iRet = tx_scanner_get_light_state();
				printf("tx_scanner_get_light_state:%d\r\n", iRet);
				break;	

			case 'j':
			case 'J':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_focus_state(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_focus_state fail!!!\r\n");
				break;

			case 'k':
			case 'K':
				iRet = tx_scanner_get_focus_state();
				printf("tx_scanner_get_focus_state:%d\r\n", iRet);
				break;
				
			case 'l':
			case 'L':
				scanf("%hd %hhd",&usTimeMs,&ucTemp2);
				printf("%d,%d\r\n", usTimeMs, ucTemp2);
			
				iRet = tx_scanner_set_once_scan_time(usTimeMs, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_once_scan_time fail!!!\r\n");
				break;
				
			case 'n':
			case 'N':
				iRet = tx_scanner_get_once_scan_time();
				printf("tx_scanner_get_once_scan_time():%d\r\n", iRet);
				break;
				
			case 'o':
			case 'O':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_en_prefix(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_en_prefix fail!!!\r\n");
				break;

			case 'p':
			case 'P':
				iRet = tx_scanner_get_en_prefix();
				printf("tx_scanner_get_en_prefix:%d\r\n", iRet);
				break;

			case 'r':
			case 'R':
				{
					uint8 ucPre[] = "ABC";
					ucTemp1 = getchar();
					ucTemp1 -= '0';

					iRet = tx_scanner_set_prefix(ucPre, strlen(ucPre), ucTemp1);
					if(iRet < 0)
						printf("tx_scanner_set_prefix fail!!!\r\n");	
				}
				break;
		
			case 'q':
			case 'Q':
				printf("quit\r\n");
				return 0;
				break;
				
			case 's':
			case 'S':
				{
					uint8 ucBuf[10];
					memset(ucBuf,0,sizeof(ucBuf));
					iRet = tx_scanner_get_prefix(ucBuf, sizeof(ucBuf));
			
					printf("%s\r\n",ucBuf);
					printf("tx_scanner_get_en_prefix:%d\r\n", iRet);
					break;
				}
			case 't':
			case 'T':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_en_suffix(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_en_suffix fail!!!\r\n");
				break;

			case 'u':
			case 'U':
				iRet = tx_scanner_get_en_suffix();
				printf("tx_scanner_get_en_suffix:%d\r\n", iRet);
				break;

			case 'v':
			case 'V':
				{
					uint8 ucSuf[]="ABC";
					ucTemp1 = getchar();
					ucTemp1 -= '0';

					iRet = tx_scanner_set_suffix(ucSuf,strlen(ucSuf), ucTemp1);
					if(iRet < 0)
						printf("tx_scanner_set_suffix fail!!!\r\n");	
					break;
				}
			
			case 'w':
			case 'W':
				{
					uint8 ucBuf[10];
					memset(ucBuf,0,sizeof(ucBuf));
					iRet = tx_scanner_get_suffix(ucBuf, sizeof(ucBuf));
			
					printf("%s\r\n",ucBuf);
					printf("tx_scanner_get_suffix:%d\r\n", iRet);
					break;
				}
				
			case 'x':
			case 'X':
				scanf("%hhd %hhd",&ucTemp1,&ucTemp2);
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
			
				iRet = tx_scanner_set_beep_volume(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_focus_state fail!!!\r\n");
				break;
				
			case 'y':
			case 'Y':
				iRet = tx_scanner_get_beep_volume();
				printf("tx_scanner_get_beep_volume():%d\r\n", iRet);
				break;
			
			case 'z':
			case 'Z':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_set_heartbeat_type(ucTemp1, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_heartbeat_type fail!!!\r\n");
				break;
				
			case '0':
				iRet = tx_scanner_get_heartbeat_type();
				printf("tx_scanner_get_heartbeat_type:%d\r\n", iRet);
				break;
			
			case '1':
			case '!':
				scanf("%d %hhd",&uiTimeMs ,&ucTemp2);
				printf("%d,%d\r\n", uiTimeMs, ucTemp2);
			
				iRet = tx_scanner_set_heartbeat_gap_time(uiTimeMs, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_once_scan_time fail!!!\r\n");
				break;
				
			case '2':
			case '@':
				iRet = tx_scanner_get_heartbeat_gap_time();
				printf("tx_scanner_get_heartbeat_gap_time():%d\r\n", iRet);
				break;

			case '3':
			case '#':
				scanf("%d %hhd",&uiTimeMs ,&ucTemp2);
				printf("%d,%d\r\n", uiTimeMs, ucTemp2);
			
				iRet = tx_scanner_set_heartbeat_wait_ack_time(uiTimeMs, ucTemp2);
				if(iRet < 0)
					printf("tx_scanner_set_heartbeat_wait_ack_time fail!!!\r\n");
				break;
				
			case '4':
			case '$':
				iRet = tx_scanner_get_heartbeat_wait_ack_time();
				printf("tx_scanner_get_heartbeat_wait_ack_time():%d\r\n", iRet);
				break;
				
			case '5':
			case '%':
				iRet = tx_scanner_reset();
				printf("RESET SUCC\r\n");
				break;
				
			case '6':
			case '^':
				ucTemp1 = getchar();
				ucTemp1 -= '0';
				printf("%d\r\n", ucTemp1);
				
				iRet = tx_scanner_scan_sw(ucTemp1);
				if(iRet > 0)
					printf("tx_scanner_scan_sw fail!!!\r\n");
				break;
				
			case '7':
			case '&':
				ucTemp1 = getchar();
				ucTemp2 = getchar();

				ucTemp1 -= '0';
				ucTemp2 -= '0';
				printf("%d,%d\r\n", ucTemp1, ucTemp2);
				iRet = tx_scanner_cmd_setcode_sw(ucTemp1, ucTemp2);
				if(iRet > 0)
					printf("tx_scanner_cmd_setcode_sw fail!!!\r\n");
				break;
				
			case '?':
			case 'm':
			case 'M':
				tx_scanner_sdk_show_menu();
				break;

			default:
				break;
		}
	}
	
	return 0;
}

static uint32 s_uiDecodeCnt = 0;
static int32 tx_scanner_sdk_decode_data_cb(uint8 ucCodeType, uint8 *pBuf, uint32 uiBufLen)
{
	printf("[%03d][%02d]len:%d,data:%s\r\n", ++s_uiDecodeCnt, ucCodeType, uiBufLen, pBuf);
}

static void tx_scanner_sdk_comm_state_cb_fun(uint8 ucState)
{
	/**0:Ͽ,1:**/
	printf("scanner comm state:%d\r\n", ucState);
}

static void tx_scanner_sdk_show_menu(void)
{
	printf("***************************MENU***************************\r\n");
	printf("a:start decode\r\n");
	printf("b:stop decode\r\n");
	printf("c:no time decode start\r\n");
	printf("d:get version info\r\n");
	printf("e:get product info\r\n");
	printf("f:set trigger mode; 0:LEVEL,1:PULSE,2:CONTINUOUS,3:AUTOSENS; save:0:no,1:yes.(eg:f01)\r\n");
	printf("g:get trigger mode\r\n");
	printf("h:set light LED; 0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:h01)\r\n");
	printf("i:get light LED\r\n");
	printf("j:set focus LED;0:working light,1:always off,2:always on; save:0:no,1:yes.(eg:j01)\r\n");
	printf("k:get focus LED\r\n");
	printf("l:set once scan time;time:(0~65535);save:0:no,1:yes.(eg:l 1000 0)\r\n");
	printf("n:get once scan time\r\n");
	printf("o:set en prefix;0:enable,0:off,1:on; save:0:no,1:yes.(eg:o10)\r\n");
	printf("p:get en prefix state\r\n");
	printf("r:set prefix content;the initial prefix is (ABCDE), needed to be changed by yourself )(eg:r0)\r\n");
	printf("s:get prefix content and length\r\n");
	printf("t:set en suffix;0:enable,0:off,1:on; save:0:no,1:yes.(eg:t10)\r\n");
	printf("u:get en suffix state\r\n");
	printf("v:set suffix content;the initial suffix is (ABCDE), needed to be changed by yourself)(eg:v1)\r\n");
	printf("w:get suffix content and length\r\n");
	printf("x:set beep volume;voice:(0~100)save:0:no,1:yes.(eg:x01)\r\n");
	printf("y:get beep volume\r\n");
	printf("z:set heartbeat type;0:disable,1:not need ack,2:need ack; save:0:no,1:yes.(eg:z20)\r\n");
	printf("0:get heartbeat type\r\n");
	printf("1:set heartbeat gap time;time:(0~2147483647);save:0:no,1:yes.(eg:1 1000 0)\r\n");
	printf("2:get heartbeat gap time\r\n");
	printf("3:set heartbeat wait ack time;time:(0~2147483647);save:0:no,1:yes.(eg:1 1000 0)\r\n");
	printf("4:get heartbeat wait ack time\r\n");
	printf("5:tx scanner reset\r\n");
	printf("6:tx scanner scan sw;(eg:6 1)\r\n");
	printf("7:tx scanner cmd setcode sw;(eg:7 1 0)\r\n");
	printf("?/m:more menu\r\n");
	printf("q:quit\r\n");
	printf("******************************************************\r\n");
}
