/********************************************************************************
*  ļ: tx_scanner.h
*  ļ: linux hidpos sdkӿں
*  ʷ¼: 
*  ʱ: 2023.05.03
*    : joy
*  ޸ʱ: 
*    ޸: 
*      : 
********************************************************************************/
#ifndef _TX_SCANNER_H_
#define _TX_SCANNER_H_

#ifdef __cplusplus
extern "C"
{
#endif
/********************************************************************************
ͷļ
********************************************************************************/
#ifdef __SDK_SRC__
#include "bf_common.h"
#endif

/********************************************************************************
궨
********************************************************************************/
#ifndef __SDK_SRC__
typedef unsigned char uint8;
typedef signed char int8;
typedef unsigned short uint16;
typedef signed short int16;
typedef unsigned int uint32;
typedef signed int int32;
typedef char CHAR;
typedef uint16 wchar;
typedef unsigned int BOOL;
typedef long long int64;
typedef unsigned long long uint64;

#ifndef SUCC
#define SUCC	0
#endif

#ifndef FAIL
#define FAIL	-1
#endif
#endif /**#ifndef __SDK_SRC__**/

/**ƷϢغ궨**/
#define DB_PRODUCT_MODEL_MAX_LEN	20	/**Ʒ󳤶**/
#define DB_PRODUCT_SN_MAX_LEN		30	/**Ʒк(ID)󳤶**/
#define DB_PRODUCT_DATE_MAX_LEN		15	/**󳤶(:20150809)**/
#define DB_PRODUCT_HVER_MAX_LEN		15	/**Ӳ汾󳤶**/
#define DB_PRODUCT_SVER_MAX_LEN		15	/**汾ɴ,󳤶**/
#define DB_PRODUCT_FLAG				(0xCF)

/********************************************************************************
ṹö١Ƚṹ
********************************************************************************/
/**ݻص**/
typedef int32 (*tx_scanner_decode_data_cb_fun)(uint8 ucCodeType, uint8 *pBuf, uint32 uiBufLen);
/**ͨŽӿ(USB)״̬0:Ͽ,1:**/
typedef void (*tx_scanner_comm_state_cb_fun)(uint8 ucState);


/**ƷϢ**/
typedef struct DB_PRODUCT_INFO_
{
	uint8 ucModel[DB_PRODUCT_MODEL_MAX_LEN];	/**Ʒ**/
	uint8 ucSn[DB_PRODUCT_SN_MAX_LEN];			/**Ʒк(SN)**/
	uint8 ucDate[DB_PRODUCT_DATE_MAX_LEN];		/****/
	uint8 ucHVer[DB_PRODUCT_HVER_MAX_LEN];		/**Ӳ汾**/
	uint8 ucSVer[DB_PRODUCT_SVER_MAX_LEN];		/**汾,ɴ**/
	uint8 ucFlag;								/**ƷϢ־λ DB_PRODUCT_FLAG**/
}DB_PRODUCT_INFO_T;

/**봥ʽ**/
typedef enum DB_TRIGGER_MODE_
{
	DB_TRIGGER_M_LEVEL	= 0x00,	/**00[](ƽ)**/	//Ĭ
	DB_TRIGGER_M_PULSE, 		/**01[]()ΰģʽ**/
	DB_TRIGGER_M_CONTINUOUS,	/**02[]ģʽ**/
	DB_TRIGGER_M_AUTOSENS,		/**03[]ԶӦģʽ**/
	
}DB_TRIGGER_MODE_E;

/**LEDƵ״̬(λƺ)**/
typedef enum DB_LED_STATE_
{
	DB_LED_S_NORMAL = 0x00, 	/**ʱ**/
	DB_LED_S_ALWAYS_OFF,		/**һֱر**/
	DB_LED_S_ALWAYS_ON, 		/**һֱ**/
	
	DB_LED_S_MAX,
}DB_LED_STATE_E;

/****/
typedef enum DB_HEARTBEAT_TYPE_
{
	DB_HEARTBEAT_T_DISABLE = 0x00,	/**ֹ, Ĭ**/
	DB_HEARTBEAT_T_NOT_ACK,			/**ҪACK**/
	DB_HEARTBEAT_T_NEED_ACK,		/**ҪACK**/

	DB_HEARTBEAT_T_MAX,
}DB_HEARTBEAT_TYPE_E;

/********************************************************************************
Դļ

extern ⲿ
********************************************************************************/


/********************************************************************************
Դļ

extern ⲿ
********************************************************************************/
/**************************************************
*: ʼ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_init(void);

/**************************************************
*: ȥʼ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_deinit(void);

/**************************************************
*: ȡSDK汾
*˵: 
*    : ucVerLen,pVerռ䳤
*    : pVer,汾Ϣ
*  ֵ: int32,ɹ:汾Ϣĳ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_version(uint8 *pVer, uint8 ucVerLen);

/**************************************************
*: עݻص
*˵: 
*    : fDataFun,ݺ
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_decode_data_fun_register(tx_scanner_decode_data_cb_fun fDataFun);

/**************************************************
*: ע豸״̬ص
*˵: 
*    : fStateFun,豸״̬
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_comm_state_fun_register(tx_scanner_comm_state_cb_fun fStateFun);

/**************************************************
*: ȡ豸汾Ϣ
*˵: 
*    : usLen,pucVerInfoռ䳤
*    : pucVerInfo,豸汾Ϣ
*  ֵ: int32,ɹ:豸汾Ϣ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_version_info(uint8 *pucVerInfo, uint16 usLen);

/**************************************************
*: ȡ豸ƷϢ
*˵: 
*    : usLen,pucProInfoռ䳤
*    : pucProInfo,豸ƷϢ
*  ֵ: int32,ɹ:豸ƷϢ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_all_product_info(uint8 *pucProInfo, uint16 usLen);

/**************************************************
*: ʼ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_decode_start(void);

/**************************************************
*: 
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_decode_stop(void);

/**************************************************
*: ʼʱ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_no_time_decode_start(void);

/**************************************************
*: ôʽ
*˵: 
*    : eMode,ʽ
*          isSaveParam,0:ʱЧ,1:Ч
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_trigger_mode(DB_TRIGGER_MODE_E eMode, uint8 isSaveParam);

/**************************************************
*: ȡʽ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:ʽ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_trigger_mode(void);

/**************************************************
*: ò״̬
*˵: 
*    : eLedState,״̬
*          isSaveParam,0:ʱЧ,1:Ч
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_light_state(DB_LED_STATE_E eLedState, uint8 isSaveParam);

/**************************************************
*: ȡ״̬
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:״̬,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_light_state(void);

/**************************************************
*: öλ״̬
*˵: 
*    : eLedState,λ״̬
*          isSaveParam,0:ʱЧ,1:Ч
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_focus_state(DB_LED_STATE_E eLedState, uint8 isSaveParam);

/**************************************************
*: ȡλ״̬
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:λ״̬,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_focus_state(void);

/**************************************************
*: ʹǰ׺
*˵: 
*	 : ucEnable,0:ֹ,1:ʹ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_en_prefix(uint8 ucEnable, uint8 isSaveParam);

/**************************************************
*: ȡʹǰ׺
*˵: 
*	 : 
*	 : 
*  ֵ: int32,ɹ:0:ֹ,1:ʹ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_en_prefix(void);

/**************************************************
*: ǰ׺,ǰ׺󳤶:10ֽ
*˵: 
*	 : pData,ǰ׺
*		   ucDataLen,ǰ׺ݳ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_prefix(uint8* pData, uint8 ucDataLen, uint8 isSaveParam);
	
/**************************************************
*: ȡǰ׺,ǰ׺󳤶:10ֽ
*˵: 
*	 : ucDataLen,ǰ׺ĳ
*	 : pData,ǰ׺
*  ֵ: int32,ɹ:ȡǰ׺,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_prefix(uint8* pData, uint8 ucDataLen);

/**************************************************
*: ʹܺ׺
*˵: 
*	 : ucEnable,0:ֹ,1:ʹ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_en_suffix(uint8 ucEnable, uint8 isSaveParam);

/**************************************************
*: ȡʹܺ׺
*˵: 
*	 : 
*	 : 
*  ֵ: int32,ɹ:0:ֹ,1:ʹ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_en_suffix(void);

/**************************************************
*: ú׺,׺󳤶:10ֽ
*˵: 
*	 : pData,׺
*		   ucDataLen,׺ݳ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_suffix(uint8* pData, uint8 ucDataLen, uint8 isSaveParam);

/**************************************************
*: ȡ׺,׺󳤶:10ֽ
*˵: 
*    : ucDataLen,׺ĳ
*    : pData,׺
*  ֵ: int32,ɹ:ȡĺ׺,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_suffix(uint8* pData, uint8 ucDataLen);

/**************************************************
*: ʾ
*˵: 
*	 : ucVol,Χ:0-100,0Ǿ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_beep_volume(uint8 ucVol, uint8 isSaveParam);

/**************************************************
*: ȡʾ
*˵: 
*	 : 
*	 : 
*  ֵ: int32,ɹ:,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_beep_volume(void);

/**************************************************
*: õɨʱ
*˵: 
*	 : usTimeMs,εʱ,λ:ms,Χ:0-65535ms,
0ʾûʱ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_once_scan_time(uint16 usTimeMs, uint8 isSaveParam);

/**************************************************
*: ȡɨʱ
*˵: 
*	 : 
*	 : 
*  ֵ: int32,ɹ:ɨʱ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_once_scan_time(void);

/**************************************************
*: 
*˵: 
*	 : eType,
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_heartbeat_type(DB_HEARTBEAT_TYPE_E eType, uint8 isSaveParam);

/**************************************************
*: ȡ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_heartbeat_type(void);

/**************************************************
*: ʱ
*˵: 
*    : uiTimeMs,ʱ,λ:ms,Χ0-2147483648
*          isSaveParam,0:ʱЧ,1:Ч
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_heartbeat_gap_time(uint32 uiTimeMs, uint8 isSaveParam);

/**************************************************
*: ȡʱ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:ʱ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_heartbeat_gap_time(void);

/**************************************************
*: ȴӦʱ
*˵: 
*    : uiTimeMs,ȴӦʱ,λ:ms,Χ0-2147483648
*          isSaveParam,0:ʱЧ,1:Ч
*    : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_set_heartbeat_wait_ack_time(uint32 uiTimeMs, uint8 isSaveParam);

/**************************************************
*: ȡȴӦʱ
*˵: 
*    : 
*    : 
*  ֵ: int32,ɹ:ȴӦʱ,ʧ:FAIL
**************************************************/
int32 tx_scanner_get_heartbeat_wait_ack_time(void);

/**************************************************
*: 豸λ
*˵: 
*	 : 
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_reset(void);

/**************************************************
*: ɨ뿪,ʱЧ
*˵: 
*	 : ucEnable,0:ֹɨ,1:ʹɨ
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_scan_sw(uint8 ucEnable);

/**************************************************
*: 뿪,ʹָֹ,
ֻʹָʹ
*˵: 
*	 : ucEnable,0:ֹ,1:ʹ
*		   isSaveParam,0:ʱЧ,1:Ч
*	 : 
*  ֵ: int32,ɹ:SUCC,ʧ:FAIL
**************************************************/
int32 tx_scanner_cmd_setcode_sw(uint8 ucEnable, uint8 isSaveParam);

#ifdef __cplusplus
}
#endif

#endif /*#ifndef _TX_SCANNER_H_*/
